#include "STANDARD.H"                           // Standard
#include "TREESTRC.H"                           // Strukture
#include "TREEASM.H"                            // Grafika
#include "TREEFUNC.H"                           // Matematika
#include "TREEFILE.H"                           // File I/O
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <i86.h>
  
char A[4096];

void Help (void);
void Intro (void);
float Val (DB a);
float R33 (DB a);
void Read_CFG (void);
void Save_Data (void);
void (__interrupt __far *prev_KeyH) ();
void  
__interrupt __far KeyH (void)
{ Check_Key ();
  if (Command.Keys[0] == 198) { Command.KeyNo = (Command.KeyNo & 2); Key = 0; }
  if (Command.Keys[1] == 198) { Command.KeyNo = (Command.KeyNo & 1); Key = 0; }
  if (Command.Keys[0] == 1)   { 
    Done = 1; }                                         // ESC = Save & EXIT
  if (Command.Release[2] == 7) {                        // Ctrl-Alt-Del = Immediate EXIT
    VESA_Exit_VGA (); _dos_setvect (9,prev_KeyH); nosound(); exit(0); }
}

void
main (int argc, char *argv[])
{
  DW i, j;
  
  if(argc == 1){ Intro (); Help (); exit(0); }
  if(argc != 3){ printf("Error in parameter! \n"); exit(0); }
  
  Done = 0;
  sscanf(argv[2],"%d",&Tree.Years);
  
  Read_CFG ();
  Init_Tree ();                         // TREEFUNC.C Izracuna drevo
  Read_Pal ();                          // TREEFILE.C Prebere paleto TREEPAL.COL
  Set_Names (argv[1]);                  // TREEFILE.C nastavi ime
  prev_KeyH = _dos_getvect (9); 
  _dos_setvect (9,KeyH);                // Nastavi keyboard interrupt
  VESA_Init_VGA ();                     // TREEASM.ASM Set 640x480x256 SVGA
  Pal_Norm_Init ();                     // TREEASM.ASM Inicializira paleto
  Save_Data ();

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  do{
    if (Command.KeyNo != 0){
      if ((Command.Keys[0] == 68) && (Command.KeyNo == 1)){
        Save_File ();
        Names.PicNo++;
        Update_Names (); }              // TREEFILE.C Shrani sliko
      Rotate ();                        // TREEFUNC.C Rotira deblo
    }
    if (Key == 1){
      PreCutIt ();
      Paste ();
      Key = 0;
    }
    if (Command.Keys[0] == 28){
      CutIt ();                         // TREEFUNC.C Preslika teksturo
      Paste ();                         // TREEASM.ASM Izrise sliko
    }
  } while (Done == 0);

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

  VESA_Exit_VGA ();                     // TREEASM.ASM Vrne v prejsnji graficni nacin
  _dos_setvect (9,prev_KeyH);           // Vrne prejsnji keyhandler
  Intro ();
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void
Help (void)
{
  printf("\n");
  printf("Usage: maketree [outfile.TGA] [yy years old tree] \n");
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void
Intro (void)
{
  printf("Make Wood Texture 1.00 Copyright (c) 1998 Miran Klemenc, Il.Bistrica Slovenija \n");
  printf("All rights reserved. Aug 9, 1998 \n");
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void 
Save_Data (void)
{
  FILE *aa;
  DW i;
  aa = fopen("TREE.ERR","w");

  fprintf(aa,"Years                 : %d \n",Tree.Years);
  fprintf(aa,"Roots                 : %1.3f %1.3f %1.3f %1.3f %1.3f\n",Tree.Roots[0],Tree.Roots[1],Tree.Roots[2],Tree.Roots[3],Tree.Roots[4]);
  for(i=0;i<Tree.Years;i++){
    fprintf(aa,"H=%3.3f R=%1.3f dR=%1.5f \n",Tree.H[i],Tree.R[i],Tree.dR[i]); }
  fclose(aa);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

float
Val (DB a)
{
  float b;
  if ((A[a] >= 0x30) && (A[a] <= 0x39)){ b = (A[a] - 0x30); } else {b=0;}
  return (b);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

float
R33 (DB a)
{
  float b;
  b = (100*Val(a) + 10*Val(a+1) + Val(a+2) + 0.1*Val(a+4) + 0.01*Val(a+5) + 0.001*Val(a+6));
  return (b);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=

void 
Read_CFG (void)
{
  FILE *aa;
  aa = fopen("TREE.CFG","rb"); fread(&A,1,4096,aa); fclose(aa);
  View.X   = R33 (0);
  View.Y   = R33 (8);
  View.Z   = R33(16);
  View.Phi = R33(27);
  View.Theta = R33(35);
  View.Zoom = R33(43);
  memcpy(&Names.PalName,&A[54],12);
}

// -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
