#include "STANDARD.H"
#include "TREEFUNC.H"
#include "TREESTRC.H"
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <i86.h>

DD GetTime (void);
DB Col (float a);
float arctan (float y, float z);

double Pi = {3.14159};
double Rad = {0.6};

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

// DW Years;                      // Koliko let je stara
// float dR[128], R[128], H[128]; // Radiji letnic in letni prirasti
// DB Veje[128];                  // Koliko vej je na letnem prirastu, max 8
// float Phi[128][8];             // Koti vej na letnem prirastu
// float HPhi[128][8];            // Visina veje

void
Init_Tree (void)
{
  DW Tdx;
  short i, j, prev;
  float Div;

  srand(GetTime ());

  Tree.Exc = ((rand() & 15)/100);
  for(i=0;i<5;i++){
    Tree.Roots[i] = ((i*Pi*2/5) + (rand() & 63)/100 - 0.32); }

  Tree.dR[0] = 0.0015;                                  // [m]
  Tree.H[0] = (80*Tree.dR[0]);
  Tree.R[0] = 0;
  Tree.Veje[0] = 0;

  prev = 0;
  for(i=1;i<Tree.Years;i++){
    Tdx = (rand() & 32767);
    if( prev < 8192 ){ Tdx = (Tdx * 0.7); } 
    prev = Tdx;
    Tree.dR[i] = (Tree.dR[i-1] - 0.0004);
    if(Tdx <   8192){ Tree.dR[i] = (Tree.dR[i-1] + 0.0013); }
    if(Tree.dR[i] < 0.0015){ Tree.dR[i] = 0.0015; }
    if(Tree.dR[i] > 0.0035){ Tree.dR[i] = 0.0035; }
    Tree.H[i] = (Tree.H[i-1] + (80*Tree.dR[i]));
    Tree.Veje[i] = (rand() & 7);
    for(j=0;j<Tree.Veje[i];j++){
      Div = (rand() & 32767);
      Tree.Phi[i][j] = ((((2*Pi)/Tree.Veje[i])*j) + (Div/32768) - 0.5);
      Tree.HPhi[i][j] = (Tree.H[i] + (Div/(32768*16.6)) - 0.03);
    }
  }
  for(i=1;i<Tree.Years;i++){ Tree.R[i] = (Tree.R[i-1] + Tree.dR[i-1]); }
  Div = Tree.R[Tree.Years-1]*16;
  i=0;
  do{ i++; } while ((Tree.R[i]*80) <= Div); 
  i++;
  for(j=0;j<i;j++){ Tree.Veje[j] = 0; }
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

void
Rotate (void)
{
  if(Command.Keys[0] == 200){ View.Y = (View.Y + 0.05*View.Zoom); Key = 1; }
  if(Command.Keys[0] == 208){ View.Y = (View.Y - 0.05*View.Zoom); Key = 1; }
  if(Command.Keys[0] == 203){ View.X = (View.X - 0.5*View.Zoom); Key = 1; }
  if(Command.Keys[0] == 205){ View.X = (View.X + 0.5*View.Zoom); Key = 1; }
  if(View.X < 0){ View.X = 0; }
  if(View.X > Tree.H[Tree.Years-1]){ View.X = Tree.H[Tree.Years-1]; }
//  if(View.Y < (-Tree.R[Tree.Years-1])){ View.Y = (-Tree.R[Tree.Years-1]); }
//  if(View.Y > Tree.R[Tree.Years-1]){ View.Y = Tree.R[Tree.Years-1]; }
                // Cursor UP => Slide screen along Y axis positive
                // Cursor DN => Slide screen along Y axis negative
                // Cursor LT => Slide screen along X axis negative
                // Cursor RT => Slide screen along X axis positive
  if((Command.Keys[0]==56) && (Command.Keys[1]==200)){ View.Z = (View.Z + 0.05*View.Zoom); Key = 1; }
  if((Command.Keys[0]==56) && (Command.Keys[1]==208)){ View.Z = (View.Z - 0.05*View.Zoom); Key = 1; }
//  if(View.Z < (-Tree.R[Tree.Years-1])){ View.Z = (-Tree.R[Tree.Years-1]); }
//  if(View.Z > Tree.R[Tree.Years-1]){ View.Z = Tree.R[Tree.Years-1]; }
                // LT Alt + Cursor UP => Slide screen along Z axis positive
                // LT Alt + Cursor DN => Slide screen along Z axis negative
  if((Command.Keys[0]==29) && (Command.Keys[1]==200)){
    View.Theta = (View.Theta - Rad*View.Zoom); Key = 1; }
  if((Command.Keys[0]==29) && (Command.Keys[1]==208)){
    View.Theta = (View.Theta + Rad*View.Zoom); Key = 1; }
  if((Command.Keys[0]==29) && (Command.Keys[1]==203)){
    View.Phi = (View.Phi - Rad*View.Zoom); Key = 1; }
  if((Command.Keys[0]==29) && (Command.Keys[1]==205)){
    View.Phi = (View.Phi + Rad*View.Zoom); Key = 1; }
  if(View.Theta < -Pi){ View.Theta = View.Theta + 2*Pi; }
  if(View.Theta > Pi){ View.Theta = View.Theta - 2*Pi; }
  if(View.Phi < -Pi){ View.Phi = View.Phi + 2*Pi; }
  if(View.Phi > Pi){ View.Phi = View.Phi - 2*Pi; }
                // LT Ctrl + Cursor UP => Tilt screen around XY plane down
                // LT Ctrl + Cursor DN => Tilt screen around XY plane up
                // LT Ctrl + Cursor LT => Tilt screen around Z axis ctr.clockwise
                // LT Ctrl + Cursor RT => Tilt screen around Z axis clockwise
  if((Command.Keys[0]==157) && (Command.KeyNo==1)){
    View.Zoom = (View.Zoom / 1.111); Key = 1; }
  if((Command.Keys[0]==184) && (Command.KeyNo==1)){
    View.Zoom = (View.Zoom * 1.111); Key = 1; }
                // RT Alt Gr  => Zoom Out
                // RT Ctrl    => Zoom In
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

DB
Col (float a)
{
  DB b;
  if (a <= 0.1){ b = (a*2540.0 + 1.0); } else
               { b = (255.0 - (a-0.1)*282.0); }
  if (a <= 0){ b = 1; }
  if (a >= 1){ b = 1; }
  return (b);
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

float
arctan (float y, float z)
{
  float b;
  if( z >= 0 ){ b = atan(y/z); } else
              { b = atan(y/z) + Pi; }
  return (b);
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

void
CutIt (void)
{
  float x, y, z, R_, Rm, Rc, r, Psi, root, droot, xx, rv, xv, phi, mul, Cmul;
  short i, j, k, l, u;
  DB C;
  
  for(j=0;j<480;j++){
  if((j & 15)==15){ sound(200); delay(10); nosound(); }
  for(i=0;i<640;i++){
    x = (View.X + ((sin(View.Phi)*(i-320)) + ((sin(View.Theta)*(j-240))*cos(View.Phi)))*View.Zoom/320);
    y = (View.Y - ((cos(View.Phi)*(i-320)) - ((sin(View.Theta)*(j-240))*sin(View.Phi)))*View.Zoom/320);
    z = (View.Z - (cos(View.Theta)*(j-240))*View.Zoom/320);

    C = 0;
    Psi = arctan(y,z);
    R_ = sqrt(pow(y,2) + pow(z,2));
    k = 0; do{ k++; } while ((Tree.H[k] < x) && (k < Tree.Years)); k--;
    root = 0;
    for(u=0;u<5;u++){
      droot = (Psi - Tree.Roots[u]);
      if (droot > Pi){ droot = (droot - 2*Pi); }
      if (droot < -Pi){ droot = (droot + 2*Pi); }
      root = (root + exp(-7.84*droot*droot));
    }
    xx = (1 - x/Tree.H[Tree.Years-1]);
    mul = 1;
    if ((x/Tree.H[Tree.Years-1]) > 0.2){
      for(u=0;u<Tree.Veje[k];u++){
        xv = Tree.HPhi[k][u];
        rv = (Tree.R[Tree.Years-1] - (xv/80)) * (1 + (sin(4*Pi*xv)*0.033)) *
             (1 + sin(Psi)*Tree.Exc);
        droot = (Psi - Tree.Phi[k][u]);
        if (droot > Pi){ droot = (droot - 2*Pi); }
        if (droot < -Pi){ droot = (droot + 2*Pi); }
        if ((x >= (xv - 3*rv/4)) && (x <= (xv + 3*rv/4)) && (droot >= -0.65) && (droot <= 0.65)){
          phi = acos((sin(Tree.Phi[k][u])*y + cos(Tree.Phi[k][u])*z)/(sqrt(pow((x-xv),2) + y*y + z*z)));
          if ((phi <= 0.65) && (phi >= 0)){ mul = mul * (1 + 32*exp(-26*phi)); }
        }
      }
      for(u=0;u<Tree.Veje[k+1];u++){
        xv = Tree.HPhi[k+1][u];
        rv = (Tree.R[Tree.Years-1] - (xv/80)) * (1 + (sin(4*Pi*xv)*0.033)) *
             (1 + sin(Psi)*Tree.Exc);
        droot = (Psi - Tree.Phi[k+1][u]);
        if (droot > Pi){ droot = (droot - 2*Pi); }
        if (droot < -Pi){ droot = (droot + 2*Pi); }
        if ((x >= (xv - 3*rv/4)) && (x <= (xv + 3*rv/4)) && (droot >= -0.65) && (droot <= 0.65)){
          phi = acos((sin(Tree.Phi[k+1][u])*y + cos(Tree.Phi[k+1][u])*z)/(sqrt(pow((x-xv),2) + y*y + z*z)));
          if ((phi <= 0.65) && (phi >= 0)){ mul = mul * (1 + 32*exp(-26*phi)); }
        }
    }}
    Rc = (Tree.R[Tree.Years-1] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) *
         (1 + sin(Psi)*Tree.Exc);
    Rm = Rc * (1 + root*0.3*pow(xx,55)) * mul;
    
    if ((x >= 0) && (x < Tree.H[Tree.Years-1]) && (R_ <= Rm)){
      l = -1; 
      do{ 
        l++;
        r = (Tree.R[l] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) * mul *
            (1 + sin(Psi)*Tree.Exc); 
        r = (r * (1 + (r/Rc)*root*0.3*pow(xx,55)));
      } while ((r < R_) && (l < Tree.Years)); l--;

      r = (Tree.R[l] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) *
          (1 + sin(Psi)*Tree.Exc) * mul; 
      r = (r * (1 + (r/Rc)*root*0.3*pow(xx,55)));
      Cmul = pow(mul,16);
      if(Cmul > 80){ Cmul = 80; }
      C = Col((R_ - r)/(Tree.dR[l] * (1 + (sin(4*Pi*x)*0.033)) * mul * Cmul *
          (1 + sin(Psi)*Tree.Exc) * (1 + (r/Rc)*root*0.3*pow(xx,55))));
    }
    VGA.Virtual[j][i] = C;  
  }}
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

void
PreCutIt (void)
{
  float x, y, z, R_, Rm, Rc, r, Psi, I, J, root, droot, xx, rv, xv, phi, mul;
  short i, j, k, l, u;
  DB C;
  
  for(j=0;j<60;j++){
  for(i=0;i<80;i++){
    I = (i-40); J=(j-30);
    x = (View.X + (sin(View.Phi)*I + sin(View.Theta)*J*cos(View.Phi))*View.Zoom/40);
    y = (View.Y - (cos(View.Phi)*I - sin(View.Theta)*J*sin(View.Phi))*View.Zoom/40);
    z = (View.Z - (cos(View.Theta)*J)*View.Zoom/40);

    C = 0;
    Psi = arctan(y,z);
    R_ = sqrt(pow(y,2) + pow(z,2));
    k = 0; do{ k++; } while ((Tree.H[k] < x) && (k < Tree.Years)); k--;
    root = 0;
    for(u=0;u<5;u++){
      droot = (Psi - Tree.Roots[u]);
      if (droot > Pi){ droot = (droot - 2*Pi); }
      if (droot < -Pi){ droot = (droot + 2*Pi); }
      root = (root + exp(-7.84*droot*droot));
    }
    xx = (1 - x/Tree.H[Tree.Years-1]);
    mul = 1;
    if ((x/Tree.H[Tree.Years-1]) > 0.2){
      for(u=0;u<Tree.Veje[k];u++){
        xv = Tree.HPhi[k][u];
        rv = (Tree.R[Tree.Years-1] - (xv/80)) * (1 + (sin(4*Pi*xv)*0.033)) *
             (1 + sin(Psi)*Tree.Exc);
        droot = (Psi - Tree.Phi[k][u]);
        if (droot > Pi){ droot = (droot - 2*Pi); }
        if (droot < -Pi){ droot = (droot + 2*Pi); }
        if ((x >= (xv - 3*rv/4)) && (x <= (xv + 3*rv/4)) && (droot >= -0.65) && (droot <= 0.65)){
          phi = acos((sin(Tree.Phi[k][u])*y + cos(Tree.Phi[k][u])*z)/(sqrt(pow((x-xv),2) + y*y + z*z)));
          if ((phi <= 0.65) && (phi >= 0)){ mul = mul * (1 + 32*exp(-26*phi)); }
        }
      }
      for(u=0;u<Tree.Veje[k+1];u++){
        xv = Tree.HPhi[k+1][u];
        rv = (Tree.R[Tree.Years-1] - (xv/80)) * (1 + (sin(4*Pi*xv)*0.033)) *
             (1 + sin(Psi)*Tree.Exc);
        droot = (Psi - Tree.Phi[k+1][u]);
        if (droot > Pi){ droot = (droot - 2*Pi); }
        if (droot < -Pi){ droot = (droot + 2*Pi); }
        if ((x >= (xv - 3*rv/4)) && (x <= (xv + 3*rv/4)) && (droot >= -0.65) && (droot <= 0.65)){
          phi = acos((sin(Tree.Phi[k+1][u])*y + cos(Tree.Phi[k+1][u])*z)/(sqrt(pow((x-xv),2) + y*y + z*z)));
          if ((phi <= 0.65) && (phi >= 0)){ mul = mul * (1 + 32*exp(-26*phi)); }
        }
    }}
    Rc = (Tree.R[Tree.Years-1] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) *
         (1 + sin(Psi)*Tree.Exc); 
    Rm = Rc * (1 + root*0.3*pow(xx,55)) * mul;
    
    if ((x >= 0) && (x < Tree.H[Tree.Years-1]) && (R_ <= Rm)){
      l = -1; 
      do{ 
        l++;
        r = (Tree.R[l] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) *
            (1 + sin(Psi)*Tree.Exc) * mul; 
        r = (r * (1 + (r/Rc)*root*0.3*pow(xx,55)));
      } while ((r < R_) && (l < Tree.Years)); l--;

      r = (Tree.R[l] - (x/80)) * (1 + (sin(4*Pi*x)*0.033)) * mul *
          (1 + sin(Psi)*Tree.Exc); 
      r = (r * (1 + (r/Rc)*root*0.3*pow(xx,55)));
      C = Col((R_ - r)/(Tree.dR[l] * (1 + (sin(4*Pi*x)*0.033)) * mul *
          (1 + sin(Psi)*Tree.Exc) * (1 + (r/Rc)*root*0.3*pow(xx,55))));
    }

    for(k=0;k<8;k++){
    for(l=0;l<8;l++){
      VGA.Virtual[j*8+k][i*8+l] = C;
    }}
  }}
}

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-

#pragma aux GetTime = \
"       mov     ebx, 046Ch      " \
"       mov     eax, [ebx]      " \
value [eax];

// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
// =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=- =-=-=-=-
